<template>
  <van-uploader :disabled="disabled" :uploadText="uploadText" :beforeRead="beforeRead" :beforeDelete="image_del"
                :after-read="_afterRead" :name="name" :accept="accept" v-model="oss_fileList" :maxSize="maxSize"
                :maxCount="maxCount" :previewImage="previewImage" :previewFullImage="previewFullImage"
                :imageFit="imageFit" :multiple="multiple" :resultType="resultType"   />
</template>

<script>
import Vue from 'vue'
import {Uploader} from 'vant'
import axios from 'axios'
import moment from 'moment'
import Exif from 'exif-js'

Vue.use(Uploader)
export default {
  model: {
    prop: 'fileList',
    event: 'fileupdate'
  },
  props: {
    multiple: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    },
    uploadText: {
      type: String,
      default: ''
    },
    afterRead: Function,
    beforeRead: Function,
    beforeDelete: Function,
    name: {
      type: [Number, String],
      default: ''
    },
    accept: {
      type: String,
      default: 'image/*'
    },
    fileList: {
      type: Array,
      default: function _default () {
        return []
      }
    },
    maxSize: {
      type: Number,
      default: Number.MAX_VALUE
    },
    maxCount: {
      type: Number,
      default: Number.MAX_VALUE
    },
    previewImage: {
      type: Boolean,
      default: true
    },
    previewFullImage: {
      type: Boolean,
      default: true
    },
    imageFit: {
      type: String,
      default: 'cover'
    },
    resultType: {
      type: String,
      default: 'dataUrl'
    }
  },
  name: 'OssUploader',
  watch: {
    fileList (val) {
      this.filelist = JSON.parse(JSON.stringify(this.fileList))
      this.dealImage()
    }
  },
  data () {
    return {
      imgBase64: [],
      config: {},
      oss_fileList: [],
      filelist: [],
      fileObj: [],
      files: {
        name: '',
        type: ''
      }
    }
  },
  created () {
    let self = this
    this.filelist = JSON.parse(JSON.stringify(this.fileList))
    self.dealImage()
  },
  methods: {
    _afterRead (file) {
      this.files.name = file.file.name // 获取文件名
      this.files.type = file.file.type // 获取类型
      this.imgPreview(file.file)
    },
    // 处理图片
    imgPreview (file) {
      let self = this
      let Orientation
      // 去获取拍照时的信息，解决拍出来的照片旋转问题   npm install exif-js --save   这里需要安装一下包
      Exif.getData(file, function () {
        Orientation = Exif.getTag(this, 'Orientation')
      })
      // 看支持不支持FileReader
      if (!file || !window.FileReader) return
      if (/^image/.test(file.type)) {
        // 创建一个reader
        let reader = new FileReader()
        // 将图片2将转成 base64 格式
        reader.readAsDataURL(file)
        // 读取成功后的回调
        reader.onloadend = function () {
          let result = this.result
          let img = new Image()
          img.src = result
          // 判断图片是否大于500K,是就直接上传，反之压缩图片
          if (this.result.length <= 500 * 1024) {
            // 上传图片
            self.postImg(this.result)
          } else {
            img.onload = function () {
              let data = self.compress(img, Orientation)
              // 上传图片
              self.postImg(data)
            }
          }
        }
      }
    },
    // 压缩图片
    compress (img, Orientation) {
      let canvas = document.createElement('canvas')
      let ctx = canvas.getContext('2d')
      // 瓦片canvas
      let tCanvas = document.createElement('canvas')
      let tctx = tCanvas.getContext('2d')
      // let initSize = img.src.length;
      let width = img.width
      let height = img.height
      // 如果图片大于四百万像素，计算压缩比并将大小压至400万以下
      let ratio
      if ((ratio = (width * height) / 4000000) > 1) {
        // console.log("大于400万像素");
        ratio = Math.sqrt(ratio)
        width /= ratio
        height /= ratio
      } else {
        ratio = 1
      }
      canvas.width = width
      canvas.height = height
      //    铺底色
      ctx.fillStyle = '#fff'
      ctx.fillRect(0, 0, canvas.width, canvas.height)
      // 如果图片像素大于100万则使用瓦片绘制
      let count
      if ((count = (width * height) / 1000000) > 1) {
        // console.log("超过100W像素");
        count = ~~(Math.sqrt(count) + 1) // 计算要分成多少块瓦片
        //      计算每块瓦片的宽和高
        let nw = ~~(width / count)
        let nh = ~~(height / count)
        tCanvas.width = nw
        tCanvas.height = nh
        for (let i = 0; i < count; i++) {
          for (let j = 0; j < count; j++) {
            tctx.drawImage(img, i * nw * ratio, j * nh * ratio, nw * ratio, nh * ratio, 0, 0, nw, nh)
            ctx.drawImage(tCanvas, i * nw, j * nh, nw, nh)
          }
        }
      } else {
        ctx.drawImage(img, 0, 0, width, height)
      }
      // 修复ios上传图片的时候 被旋转的问题
      if (Orientation != '' && Orientation != 1) {
        switch (Orientation) {
          case 6: // 需要顺时针（向左）90度旋转
            this.rotateImg(img, 'left', canvas)
            break
          case 8: // 需要逆时针（向右）90度旋转
            this.rotateImg(img, 'right', canvas)
            break
          case 3: // 需要180度旋转
            this.rotateImg(img, 'right', canvas) // 转两次
            this.rotateImg(img, 'right', canvas)
            break
        }
      }
      // 进行最小压缩
      let ndata = canvas.toDataURL('image/jpeg', 0.1)
      tCanvas.width = tCanvas.height = canvas.width = canvas.height = 0
      return ndata
    },
    // 旋转图片
    rotateImg (img, direction, canvas) {
      // 最小与最大旋转方向，图片旋转4次后回到原方向
      const min_step = 0
      const max_step = 3
      if (img == null) return
      // img的高度和宽度不能在img元素隐藏后获取，否则会出错
      let height = img.height
      let width = img.width
      let step = 2
      if (step == null) {
        step = min_step
      }
      if (direction == 'right') {
        step++
        // 旋转到原位置，即超过最大值
        step > max_step && (step = min_step)
      } else {
        step--
        step < min_step && (step = max_step)
      }
      // 旋转角度以弧度值为参数
      let degree = (step * 90 * Math.PI) / 180
      let ctx = canvas.getContext('2d')
      switch (step) {
        case 0:
          canvas.width = width
          canvas.height = height
          ctx.drawImage(img, 0, 0)
          break
        case 1:
          canvas.width = height
          canvas.height = width
          ctx.rotate(degree)
          ctx.drawImage(img, 0, -height)
          break
        case 2:
          canvas.width = width
          canvas.height = height
          ctx.rotate(degree)
          ctx.drawImage(img, -width, -height)
          break
        case 3:
          canvas.width = height
          canvas.height = width
          ctx.rotate(degree)
          ctx.drawImage(img, -width, 0)
          break
      }
    },
    // 将base64转换为文件
    dataURLtoFile (dataurl) {
      var arr = dataurl.split(','),
        bstr = atob(arr[1]),
        n = bstr.length,
        u8arr = new Uint8Array(n)
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n)
      }
      return new File([u8arr], this.files.name, {
        type: this.files.type
      })
    },
    // 提交图片到后端
    postImg (base64) {
      let file = this.dataURLtoFile(base64)
      let formData = new window.FormData()
      formData.append('file', file)
      if (file.length) {
        for (let i in file) {
          this.getSign(file[i])
        }
      } else {
        this.getSign(file)
      }
      // 提交图片
      // Some code
    },

    dealImage () {
      let self = this
      self.fileObj = []
      self.oss_fileList = []
      for (let i in this.filelist) {
        self.fileObj.push({url: this.filelist[i]})
        self.oss_fileList = JSON.parse(JSON.stringify(self.fileObj))
      }
    },
    image_del (file, i) {
      this.filelist.splice(i.index, 1)
      this.fileObj.splice(i.index, 1)
      this.oss_fileList.splice(i.index, 1)
      this.$emit('fileupdate', this.filelist)
    },
    random_string (len) {
      len = len || 32
      var chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678'
      var maxPos = chars.length
      var pwd = ''
      for (let i = 0; i < len; i++) {
        pwd += chars.charAt(Math.floor(Math.random() * maxPos))
      }
      return pwd
    },
    upload (item) {
      const photo = item // 获取图片对象
      const photoName = item.name // 原图片的名称
      const url = process.env.ALIOSS_URL
      let date = moment().format('YYYY/MM/DD')
      let param = new FormData()
      let randomStr = this.random_string(32)
      let key = this.config.key
      param.append('Filename', photoName)
      param.append('key', key)
      param.append('policy', this.config.policy)
      param.append('OSSAccessKeyId', this.config.id)
      param.append('success_action_status', '200') // 不要问为什么，照做
      param.append('callback', this.config.callback)
      param.append('signature', this.config.signature)
      param.append('file', photo) // 这个**切记**一定要放到最后去 append ，不然阿里云会一直报 key 的错误
      axios.post(url, param, {
        headers: {
          'Content-Type': 'multipart/form-data'
        }
      }).then(response => {
        if (response.status == 200 && response.statusText == 'OK') {
          this.filelist.push(process.env.ALIOSS_CDN_URL + '/' + key)
          this.$emit('fileupdate', this.filelist)
        } else {
          this.oss_fileList = JSON.parse(JSON.stringify(this.fileObj))
        }
        this.$toast.clear()
      }).catch(err => {
        this.$toast.clear()
      })
    },
    getSign (file, data) {
      const user_info = this.$store.getters.user_info || JSON.parse(localStorage.getItem('user_info')).data || JSON.parse(plus.storage.getItem('user_info')).data
      this.$toast.loading({
        mask: true,
        message: '正在上传'
      })
      var url = process.env.IMG_UPLOADER_URL
      axios.post(url, {
        md5: this.random_string(32),
        'name': file.name
      }).then((res) => {
        this.config = {callback: '', expire: res.data.data.expire, key: 'intesys/gdy/' + user_info.site_id + '/' + moment().format('YYYY-MM-DD') + '/' + this.random_string(32) + '.jpg', id: res.data.data.accessid, signature: res.data.data.signature, policy: res.data.data.policy}
        this.upload(file, data)
      })
    }
  }
}
</script>

<style scoped>

</style>
